import { unwrap as _unwrap, unwrapKey } from '@collectable/core';
import { isNone } from '../internals';
export function unwrap(tree, target) {
    if (tree._size === 0) {
        return {};
    }
    var stack = new Array(Math.ceil(Math.log(tree._size)) * 2);
    var i = 0, node = tree._root, branch = 1 /* LEFT */;
    do {
        target[unwrapKey(node.key)] = _unwrap(node.value);
        if (branch === 1 /* LEFT */) {
            if (!isNone(node._left)) {
                stack[i++] = [node, 2 /* RIGHT */];
                node = node._left;
                branch = 1 /* LEFT */;
                continue;
            }
            else {
                branch = 2 /* RIGHT */;
            }
        }
        if (branch === 2 /* RIGHT */) {
            if (!isNone(node._right)) {
                stack[i++] = [node, 0 /* NONE */];
                node = node._right;
                branch = 1 /* LEFT */;
                continue;
            }
            else {
                branch = 0 /* NONE */;
            }
        }
        if (branch === 0 /* NONE */ && i > 0) {
            --i;
            node = stack[i][0];
            branch = stack[i][1];
        }
    } while (i > 0 || branch !== 0 /* NONE */);
    return target;
}

//# sourceMappingURL=unwrap.js.map
